libstdc++: std::tr2::bool_set Class Reference

libstdc++

std::tr2::bool_set Class Reference

`#include <bool_set>`

## Public Member Functions
constexpr | bool_set ()
constexpr | bool_set (bool __t)
bool | contains (bool_set __b) const
bool | equals (bool_set __b) const
bool | is_emptyset () const
bool | is_indeterminate () const
bool | is_singleton () const
| operator bool () const

## Static Public Member Functions
static bool_set | emptyset ()
static bool_set | indeterminate ()

## Friends
bool_set | operator! (bool_set __b)
bool_set | operator& (bool_set __s, bool_set __t)
template<typename CharT, typename Traits>
std::basic_ostream< CharT, Traits > & | operator<< (std::basic_ostream< CharT, Traits > &__out, bool_set __b)
bool_set | operator== (bool_set __s, bool_set __t)
template<typename CharT, typename Traits>
std::basic_istream< CharT, Traits > & | operator>> (std::basic_istream< CharT, Traits > &__in, bool_set &__b)
bool_set | operator^ (bool_set __s, bool_set __t)
bool_set | operator| (bool_set __s, bool_set __t)

## Detailed Description

bool_set

See N2136, Bool_set: multi-valued logic by Hervé Brönnimann, Guillaume Melquiond, Sylvain Pion.

The implicit conversion to bool is slippery! I may use the new explicit conversion. This has been specialized in the language so that in contexts requiring a bool the conversion happens implicitly. Thus most objections should be eliminated.

Definition at line 56 of file bool_set.

## Constructor & Destructor Documentation

## ◆ bool_set() [1/2]

std::tr2::bool_set::bool_set | ( |  | ) |
| inlineconstexpr

Default constructor.

Definition at line 61 of file bool_set.

Referenced by equals().

## ◆ bool_set() [2/2]

std::tr2::bool_set::bool_set | ( | bool | __t | ) |
| inlineconstexpr

Constructor from bool.

Definition at line 64 of file bool_set.

## Member Function Documentation

## ◆ contains()

bool std::tr2::bool_set::contains | ( | bool_set | __b | ) | const
| inline

Definition at line 67 of file bool_set.

## ◆ emptyset()

bool_set std::tr2::bool_set::emptyset | ( |  | ) |
| inlinestatic

Definition at line 104 of file bool_set.

## ◆ equals()

bool std::tr2::bool_set::equals | ( | bool_set | __b | ) | const
| inline

Return true if states are equal.

Definition at line 71 of file bool_set.

References bool_set().

## ◆ indeterminate()

bool_set std::tr2::bool_set::indeterminate | ( |  | ) |
| inlinestatic

Definition at line 96 of file bool_set.

## ◆ is_emptyset()

bool std::tr2::bool_set::is_emptyset | ( |  | ) | const
| inline

Return true if this is empty.

Definition at line 75 of file bool_set.

## ◆ is_indeterminate()

bool std::tr2::bool_set::is_indeterminate | ( |  | ) | const
| inline

Return true if this is indeterminate.

Definition at line 79 of file bool_set.

## ◆ is_singleton()

bool std::tr2::bool_set::is_singleton | ( |  | ) | const
| inline

Return true if this is false or true (normal boolean).

Definition at line 83 of file bool_set.

Referenced by operator bool().

## ◆ operator bool()

std::tr2::bool_set::operator bool | ( |  | ) | const
| inline

Conversion to bool.

Definition at line 88 of file bool_set.

References is_singleton().

## Friends And Related Symbol Documentation

## ◆ operator!

bool_set operator! | ( | bool_set | __b | ) |
| friend

Definition at line 112 of file bool_set.

## ◆ operator&

bool_set operator& | ( | bool_set | __s,
|  | bool_set | __t )
| friend

Definition at line 124 of file bool_set.

## ◆ operator<<

template<typename CharT, typename Traits>

std::basic_ostream< CharT, Traits > & operator<< | ( | std::basic_ostream< CharT, Traits > & | __out,
|  | bool_set | __b )
| friend

Definition at line 135 of file bool_set.

## ◆ operator==

bool_set operator== | ( | bool_set | __s,
|  | bool_set | __t )
| friend

Definition at line 128 of file bool_set.

## ◆ operator>>

template<typename CharT, typename Traits>

std::basic_istream< CharT, Traits > & operator>> | ( | std::basic_istream< CharT, Traits > & | __in,
|  | bool_set & | __b )
| friend

Definition at line 144 of file bool_set.

## ◆ operator^

bool_set operator^ | ( | bool_set | __s,
|  | bool_set | __t )
| friend

Definition at line 116 of file bool_set.

## ◆ operator|

bool_set operator| | ( | bool_set | __s,
|  | bool_set | __t )
| friend

Definition at line 120 of file bool_set.

The documentation for this class was generated from the following files:

- bool_set
- bool_set.tcc